/******************************************************************************
Ootake
EX[p[OtBbNXɑΉBv0.89
E32rbgJ[ɂΉ邽߁AVCE.cłRGB̕ϊɁARGB333̂܂
  f[^𑗂o悤ɂB
ELύXɔA[h͌ݖBi[h𗘗pĂ\tg
  DDSCREEN.cŎ\j
E352[h́Aʏ̃erʂł̎\͈͂ł336hbgԂ񂾂G
  R[h悤ɂB(Ee8hbgԂ񂸂̓erʏł͌Ȃ)
E544[h̕\ɑΉBi352[hƓlɁAE16hbgԂ񂸂Jb
  g512hbgԂ񂾂GR[hj
Eerʂ̉\𑜓x́AVCERg[WX^̃hbgNbNlŌ
  悤ɂBV[eBOQ[̏cʃ[h@lɓB
E\𑜓xɂłerʗ[̖\̈iсj́AɃXvCg
  ̓FŖ߂悤ɂBiVOQrWAV[Ȃǂ@lɍČj
ETVւ̐\Jnʒuj[Nȃ\tgɂΉBv0.57B

Copyright(C)2006-2007 Kitao Nakamura.
	ŁEpłJȂƂ͕K\[XR[hYtĂB
	̍ۂɎł܂܂̂ŁAЂƂƂm点ƍKłB
	Iȗp͋ւ܂B
	Ƃ́uGNU General Public License(ʌOp_)vɏ܂B

*******************************************************************************
	[VCE.c]
		Implements the VCE.

	Copyright (C) 2004-2005 Ki

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
******************************************************************************/
#include <stdio.h>
#include <malloc.h>
#include "VCE.h"
#include "Screen.h"
#include "VDC.h" //Kitaoǉ
#include "MainBoard.h" //Kitaoǉ

/*
	[DEV NOTE]
	KitaoXVB32rbgJ[ɂΉ邽߁AVCE.cłRGB̕ϊɁARGB333̂܂܃f[^𑗂o悤ɂB
	ݔ[h͖iDDSCREEN̂قɎjB
*/
static Uint8		_DCC;
static Uint16		_ColorTableAddr;
static Sint32		_TvStartPos; //KitaoǉBer̐\Jnʒu
static Sint32		_TvWidth; //KitaoǉBer̐\(𑜓x)

static Uint16		_Palette333[512]; //KitaoǋLB0`255BGpB256`511XvCgp
static Uint32		_Palette[512]; //KitaoXVB`掞Ɉ₷悤Uint32Łu0RGBv32rbgŕێB
static Uint16		_ColorLatch;

static Sint32		_VpcPriority[4]; //KitaoǉBX[p[OtBbNXpB`̗D揇ʁBS̈Ԃ(炭[2][3]͂ǂ炩PgꂸR̈ƂȂ)
static Sint32		_VpcBorder1; //KitaoǉBX[p[OtBbNXpB̈Rɕ邽߂̋EcP
static Sint32		_VpcBorder2; //KitaoǉBX[p[OtBbNXpB̈Rɕ邽߂̋EcQ


/*
	[write_palette]

	convert GRB333 --> RGB555 / RGB565
	and write to the palette.

	basic logic:

	Uint8 G = (color & 0x1c0) >> 6;
	Uint8 R = (color & 0x038) >> 3;
	Uint8 B = (color & 0x007) >> 0;

	Rshift = 10;
	Gshift = 5;
	Bshift = 0;

	_Palette[addr]	= R << (Rshift+2);
	_Palette[addr] |= G << (Gshift+2);
	_Palette[addr] |= B << (Bshift+2);
*/
static inline void
write_palette(
	Uint16		addr,
	Uint16		color)
{
	int i;

	//KitaoXVBu0RGBv32rbgϐ֊i[悤ɂB
	_Palette333[addr] = color;

	Uint32 c=((color & 0x0038)<<13)|((color & 0x01C0)<<2)|(color & 0x0007);

	if (addr == 0x0000) //BGppbgF
	{
		for (i = 0x0000; i <= 0x00F0; i += 16)
			_Palette[i] = c;
	}
	else if (addr == 0x0100) //XvCgppbgF
	{
		for (i = 0x0100; i <= 0x01F0; i += 16)
			_Palette[i] = c;
	}
	else if ((addr & 0xF) != 0) //FȊOȂ
	{
		_Palette[addr] = c;
	}
}


/*
	[read_palette]

	convert RGB555 / RGB565 --> GRB333

	basic logic:

	Uint8 R = (_Palette[addr] & 0x7c00) >> 10;
	Uint8 G = (_Palette[addr] & 0x03e0) >> 5;
	Uint8 B = (_Palette[addr] & 0x001f) >> 0;

	G >>= 2; R >>=	2; B >>= 2;

	return (G << 6) | (R << 3) | B;

	 0RRR RRGG GGGB BBBB
   & 0111 0011 1001 1100  (0x739c)
   = 0RRR 00GG G00B BB00

	 0000 000G GGRR RBBB
*/
static inline Uint16
read_palette(
	Uint16		addr)
{
	return _Palette333[addr];
}


//KitaoǉBTVʏł̕\ݒ肷
static inline void
set_TvWidth()
{
			if (_DCC & 2)
				_TvWidth = 512;
			else if (_DCC & 1)
				_TvWidth = 336;
			else
				_TvWidth = 256;
}

/*-----------------------------------------------------------------------------
	[VCE_Write]
		VCEւ̏ݓLq܂B
-----------------------------------------------------------------------------*/
void
VCE_Write(
	Uint32	regNum,
	Uint8	data)
{
	switch (regNum & 7)
	{
		case 0: /* Rg[WX^ k */
			// (hbgNbNw肷) 
			_DCC = data & 0x87;
			set_TvWidth(); //Kitaoǉ
			VCE_SetTvStartPos(VDC_GetHDS()); //KitaoǉB\JnʒuXV
			VDC_SetTvStartLine(); //KitaoǉB\JnʒuXV
			return;

		case 1: /* Rg[WX^ g */
			return;

		case 2:	/* J[e[uAhX k */
			_ColorTableAddr &= 0x100;
			_ColorTableAddr |= data;
			return;

		case 3:	/* J[e[uAhX g */
			_ColorTableAddr &= 0xFF;
			_ColorTableAddr |= (data & 1) << 8;
			return;

		case 4:	/* J[e[uf[^Cg k */
			_ColorLatch &= 0x100;
			_ColorLatch |= data;
			return;

		case 5:	/* J[e[uf[^Cg g */
			_ColorLatch &= 0xFF;
			_ColorLatch |= (data & 1) << 8;
			write_palette(_ColorTableAddr, _ColorLatch);
			_ColorTableAddr++;
			_ColorTableAddr &= 0x1FF;
			return;
	}
}


/*-----------------------------------------------------------------------------
	[VCE_Read]
		VCE̓ǂݏoLq܂D
-----------------------------------------------------------------------------*/
Uint8
VCE_Read(
	Uint32	regNum)
{
	Uint8	ret;

	switch (regNum)
	{
		case 4:	/* J[e[uf[^[h k */
			return (Uint8)read_palette(_ColorTableAddr);
		case 5:	/* J[e[uf[^[h g */
			ret = (Uint8)(read_palette(_ColorTableAddr) >> 8) | 0xFE;
			_ColorTableAddr++;
			_ColorTableAddr &= 0x1FF;
			return ret;
	}

	return 0;
}


//`悷PCGR[hBKitaoXVB
void
VCE_EncodeLine(
	Uint32*			pDst,		// out: encoded pixels (RGB333) KitaoXV
	const Uint8*	pSrc0,		// in:	palette index (8-bit)
	const Uint8*	pSpBg0,		// in:	SP / BG bit array
	Sint32			width0,		// in:	scanline width (W̔{Ŏw肷) 
	const Uint8*	pSrc1,		// KitaoǉBXpOp
	const Uint8*	pSpBg1,		// KitaoǉBXpOp
	Sint32			width1)		// KitaoǉBXpOp
{
	int			i;
	Uint32		Palette;
	Uint8		spbg0;
	Uint8		spbg1;
	Uint8		s0;
	Uint8		s1;
	Sint32		x;
	Sint32		n;
	Uint32*		pSrc32;
	Uint32*		pSpBg32;
	Uint32		s32;
	Uint32		spbg32;

//	if (_DCC & 0x80) //KitaoXVBł͔ւ̃GR[h͂Ȃ悤ɂB
//	{
//	}

//KitaoeXgp
/*
if (WINMAIN_GetBreakTrap())
{
	char s[100];
	sprintf(s,"Kekka=%d, %d, %d, %d",(int)_TvWidth,(int)width,(int)VDC_GetHDS(),(int)_TvStartPos);
	int ok;
	ok = MessageBox(WINMAIN_GetHwnd(),
			s,
			"Test",
			MB_YESNO); //KitaoeXg
	if (ok != IDYES)
		WINMAIN_SetBreakTrap(FALSE);
}
*/

	if (VDC_GetSuperGrafx() == 0)
	{
		//v0.95XVB̂߂Ƀ[h32rbgPʂōs悤ɂB
		pSrc32 = (Uint32*)(pSrc0 + _TvStartPos);
		pSpBg32 = (Uint32*)(pSpBg0 + _TvStartPos);
		
		if (width0 > _TvWidth)
			width0 = _TvWidth / 8;
		else
			width0 /= 8;
		while (width0-- > 0)
		{
			s32 = *pSrc32++;
			spbg32 = *pSpBg32++;
			*pDst++ = _Palette[((s32 & 0x000000FF)    )|(((spbg32 & 0x000000FF)<< 8) & 0x100)];
			*pDst++ = _Palette[((s32 & 0x0000FF00)>> 8)|(((spbg32 & 0x0000FF00)    ) & 0x100)];
			*pDst++ = _Palette[((s32 & 0x00FF0000)>>16)|(((spbg32 & 0x00FF0000)>> 8) & 0x100)];
			*pDst++ = _Palette[((s32 & 0xFF000000)>>24)|(((spbg32 & 0xFF000000)>>16) & 0x100)];
			s32 = *pSrc32++;
			spbg32 = *pSpBg32++;
			*pDst++ = _Palette[((s32 & 0x000000FF)    )|(((spbg32 & 0x000000FF)<< 8) & 0x100)];
			*pDst++ = _Palette[((s32 & 0x0000FF00)>> 8)|(((spbg32 & 0x0000FF00)    ) & 0x100)];
			*pDst++ = _Palette[((s32 & 0x00FF0000)>>16)|(((spbg32 & 0x00FF0000)>> 8) & 0x100)];
			*pDst++ = _Palette[((s32 & 0xFF000000)>>24)|(((spbg32 & 0xFF000000)>>16) & 0x100)];
		}
	}
	else //X[p[OtBbNXpBKitaoǉBv0.89B
	{
		//PRINTF("Priority = %x, %x, %x, %x (%d, %d)", _VpcPriority[0], _VpcPriority[1], _VpcPriority[2], _VpcPriority[3], _VpcBorder1, _VpcBorder2); //Testp
		
		pSrc0 += _TvStartPos;
		pSpBg0 += _TvStartPos;
		pSrc1 += _TvStartPos;
		pSpBg1 += _TvStartPos;
		if (width1 > _TvWidth)
			width1 = _TvWidth;
		if (width1 > width0)
			width0 = width1; //width0width1قȂ\tg邩킩ȂAƂ肦̑傫قɍ킹ĂB
		
		//Border1<Border2̏ꍇzB炭ʏ͂BBorder1>Border2͎gĂ\tgׂB
		x = 0; //JE^
		for (i=3; i>=0; i--)
		{
			switch (i)
			{
				case 3: //[Border1܂ł`
					n = _VpcBorder1 + 1;
					if (n > width0)
						n = width0;
					break;
				//case 2: //ݔgpBBorder1>Border2͎gĂ\tgB
				//	continue;
				case 1: //Border1Border2܂ł`
					n = _VpcBorder2 + 1;
					if (n > width0)
						n = width0;
					break;
				case 0: //Border2E`Bʏ͂ꂾgQ[B
					n = width0;
					break;
				default:
					n = 0; //RpCG[h~̂߂̏
					break;
			}
			switch (_VpcPriority[i])
			{
				//VDC1\i2rbg01j
				case 0x1:
				case 0xD:
				case 0x5:
				case 0x9:
					while (x < n)
					{
						*pDst++ = _Palette[*pSrc0++|((*pSpBg0++ & 1)<<8)];
						pSrc1++;
						pSpBg1++;
						x++;
					}
					break;
				
				//VDC2\i2rbg10j
				case 0x2:
				case 0xE:
				case 0x6:
				case 0xA:
					while (x < n)
					{
						*pDst++ = _Palette[*pSrc1++|((*pSpBg1++ & 1)<<8)];
						pSrc0++;
						pSpBg0++;
						x++;
					}
					break;
				
				//VDC1DVDC1,VDC2Ƃ\i2rbg11܂00j
				case 0x3: //VDC1D
				case 0xF: //0xFc2rbg11̂Ƃ00̂ƂƓlɂB
				case 0x0:
				case 0xC:
					while (x < n)
					{
						s0 = *pSrc0++;
						s1 = *pSrc1++;
						if (((s0 & 0xF) == 0)&& //VDC1F
							((s1 & 0xF) != 0)) //VDC2Ȃ
						{
							pSpBg0++;
							Palette = _Palette[s1|((*pSpBg1++ & 1)<<8)];
						}
						else
						{
							Palette = _Palette[s0|((*pSpBg0++ & 1)<<8)];
							pSpBg1++;
						}
						*pDst++ = Palette;
						
						x++;
					}
					break;
				case 0x7: //VDC2̃XvCgVDC1BGOɏo(VDC1̃XvCg͌)
				case 0x4:
					while (x < n)
					{
						spbg0 = *pSpBg0++ & 1;
						s0 = *pSrc0++;
						Palette = _Palette[s0|(spbg0<<8)];
						spbg1 = *pSpBg1++ & 1;
						if (spbg1 == 1) //VDC2̃hbgXvCgȂ
						{
							if ((spbg0 == 0)|| //VDC1̃hbgBGȂ
							    ((s0 & 0xF) == 0)) //XvCgłVDC1FȂ
							{
								s1 = *pSrc1++;
								if ((s1 & 0xF) != 0) //VDC2̃XvCgȂ
									Palette = _Palette[s1|256];
							}
							else
								pSrc1++;
						}
						else //VDC2̃hbgBGȂ
						{
							if ((spbg0 == 0)&&((s0 & 0xF) == 0)) //VDC1BGœȂ
							{
								s1 = *pSrc1++;
								if ((s1 & 0xF) != 0) //VDC2BGȂ
									Palette = _Palette[s1];
							}
							else
								pSrc1++;
						}
						*pDst++ = Palette;
						
						x++;
					}
					break;
				case 0xB: //VDC1̃XvCgVDC2BGɉB(VDC2̃XvCg͑O)
				case 0x8:
					//PRINTF("Test VpcPriority No.2!"); //Testp
					while (x < n)
					{
						spbg0 = *pSpBg0++ & 1;
						s0 = *pSrc0++;
						Palette = _Palette[s0|(spbg0<<8)];
						spbg1 = *pSpBg1++ & 1;
						if (spbg1 == 1) //VDC2̃hbgXvCgȂ
						{
							if ((spbg0 == 0)|| //VDC1̃hbgBGȂ
							    ((s0 & 0xF) == 0)) //XvCgłVDC1FȂ
							{
								s1 = *pSrc1++;
								if ((s1 & 0xF) != 0) //VDC2̃XvCgȂ
									Palette = _Palette[s1|256];
							}
							else
								pSrc1++;
						}
						else //VDC2̃hbgBGȂ
						{
							if (((spbg0 == 0)&&((s0 & 0xF) == 0))|| //VDC1BGœȂ
								(spbg0 == 1)) //VDC1XvCgȂ
							{
								s1 = *pSrc1++;
								if ((s1 & 0xF) != 0) //VDC2BGȂ
									Palette = _Palette[s1];
							}
							else
								pSrc1++;
						}
						*pDst++ = Palette;
						
						x++;
					}
					break;
			}
		}
	}
}


//KitaoǉBX[p[OtBbNXpBVPC̃WX^ɒl񂾂Ƃ̏
void
VCE_SetVpcPriority(
	Sint32	priority0,
	Sint32	priority1,
	Sint32	priority2,
	Sint32	priority3,
	Sint32	border1,
	Sint32	border2)
{
	_VpcPriority[0] = priority0;
	_VpcPriority[1] = priority1;
	_VpcPriority[2] = priority2;
	_VpcPriority[3] = priority3;
	_VpcBorder1 = border1;
	_VpcBorder2 = border2;
}


//KitaoǉBerʂ̐\Jnʒuݒ肷B
inline void
VCE_SetTvStartPos(
	Uint8	data)
{
	if (_TvWidth == 256)
		_TvStartPos = (2 - data) * 8; //256̏ꍇقƂǂdata=2
	else if (_TvWidth == 336)
		_TvStartPos = (4 - data) * 8; //352̏ꍇAقƂǂdata=3ōE8hbgJbgBNCYal̖](data=2)͍16hbgJbgBVn炤(data=3)͉368ō8hbgE24hbgJbg336hbgƂďóB
	else //(_TvWidth == 512)
		_TvStartPos = (11 - data) * 8; //512(V[bNz[Y)̏ꍇdata=11B544[h̏ꍇdata=8(TVX|[coXP̑II)B
	if (VDC_GetScreenWidth() < _TvWidth)
		_TvStartPos -= (_TvWidth - VDC_GetScreenWidth()) * 2;
	if (_TvStartPos < 0) //VCẼhbgNbNScreenWidthύXꂽꍇɋN蓾BTVX|[coXPŊmFB
		_TvStartPos = 0;
}


//KitaoǉBerʂ̉\𑜓xihbgNbNŌ܂jԂB
inline Sint32
VCE_GetTvWidth()
{
	return _TvWidth;
}

//Kitaoǉ
inline Uint8
VCE_GetDCC()
{
	return _DCC;
}


//KitaoǉB\JnʒuԂB
inline Sint32
VCE_GetTvStartPos()
{
	return _TvStartPos;
}


//KitaoǉBXvCg̓F32rbgJ[ŕԂB
inline Uint32
VCE_GetSpColor0100()
{
	return _Palette[0x0100]; //XvCg̓F
}


/*-----------------------------------------------------------------------------
	[VCE_Init]
		ubd܂B
-----------------------------------------------------------------------------*/
Sint32
VCE_Init()
{
	int	i;

	for (i = 0x000; i < 0x200; i++) //NwiF𔒂
	{
		_Palette333[i] = 0x1FF;
		_Palette[i] = 0x00070707; //KitaoXVB
	}

	_DCC = 0;
	_ColorTableAddr = 0;
	_ColorLatch = 0;
	_TvStartPos = 0; //Kitaoǉ
	_TvWidth = 256; //Kitaoǉ

	//KitaoǉBXpOp
	for (i=0; i<=3; i++)
		_VpcPriority[i] = 0;
	_VpcBorder1 = 0;
	_VpcBorder2 = 0;

	return 0;
}


// save variable
#define SAVE_V(V)	if (fwrite(&V, sizeof(V), 1, p) != 1)	return FALSE
#define LOAD_V(V)	if (fread(&V, sizeof(V), 1, p) != 1)	return FALSE
// save array
#define SAVE_A(A)	if (fwrite(A, sizeof(A), 1, p) != 1)	return FALSE
#define LOAD_A(A)	if (fread(A, sizeof(A), 1, p) != 1)		return FALSE
/*-----------------------------------------------------------------------------
	[SaveState]
		Ԃt@Cɕۑ܂B 
-----------------------------------------------------------------------------*/
BOOL
VCE_SaveState(
	FILE*		p)
{
	if (p == NULL)
		return FALSE;

	SAVE_V(_DCC);
	SAVE_V(_ColorTableAddr);
	SAVE_V(_TvStartPos); //KitaoǉB0.57
	SAVE_V(_TvWidth); //KitaoǉB0.57

	SAVE_A(_Palette333);
	SAVE_A(_Palette);

	SAVE_V(_ColorLatch);

	SAVE_A(_VpcPriority); //v0.89ǉ
	SAVE_V(_VpcBorder1); //v0.89ǉ
	SAVE_V(_VpcBorder2); //v0.89ǉ

	return TRUE;
}


/*-----------------------------------------------------------------------------
	[LoadState]
		Ԃt@Cǂݍ݂܂B 
-----------------------------------------------------------------------------*/
BOOL
VCE_LoadState(
	FILE*		p)
{
	if (p == NULL)
		return FALSE;

	LOAD_V(_DCC);
	LOAD_V(_ColorTableAddr);
	if (MAINBOARD_GetStateVersion() >= 3) //KitaoǉBv0.57ȍ~̃Z[ut@CȂ
	{
		LOAD_V(_TvStartPos);
		LOAD_V(_TvWidth);
	}
	else
	{
		set_TvWidth();
		VCE_SetTvStartPos(VDC_GetHDS());
	}
	VDC_SetTvStartLine2(); //KitaoǉB\Jnʒu&VBlankLineXV(XpȌꍇVDCQƂXV)

	LOAD_A(_Palette333);
	LOAD_A(_Palette);

	LOAD_V(_ColorLatch);

	if (MAINBOARD_GetStateVersion() >= 17) //KitaoǉBv0.89ȍ~̃Z[ut@CȂ
	{
		LOAD_A(_VpcPriority);
		VDC_SetVpcPriority(); //v0.91O_VpcProprity͎dlႤ̂łŉ߂čXVB
		LOAD_V(_VpcBorder1);
		LOAD_V(_VpcBorder2);
	}

	return TRUE;
}

#undef SAVE_V
#undef SAVE_A
#undef LOAD_V
#undef LOAD_A
